package org.codehaus.mojo.castor;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on castor-maven-plugin.<br/> Call <pre>  mvn castor:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Thu Mar 24 13:57:56 CET 2011
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.6)
 * @goal help
 * @requiresProject false
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "org.codehaus.mojo:castor-maven-plugin:2.1", 0 );
        append( sb, "", 0 );

        append( sb, "Castor Maven Plugin", 0 );
        append( sb, "The Castor plugin is a Maven plugin that provides the functionality of Castor\'s XML SourceGenerator for generating Java beans and associated marshallers and unmarshallers from XML schema files.", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 4 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "generate".equals( goal ) )
        {
            append( sb, "castor:generate", 0 );
            append( sb, "A mojo that uses Castor to generate a collection of javabeans from an XSD. Detailed explanations of many of these can be found in the details for the Castor SourceGenerator.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "bindingfile", 2 );
                append( sb, "The binding file to use for mapping xml to java.", 3 );
                append( sb, "", 0 );

                append( sb, "classGenerationMode (Default: standard)", 2 );
                append( sb, "The method to use for Java class generation; possible values are \'standard\' (default) and \'velocity\'.", 3 );
                append( sb, "", 0 );

                append( sb, "createJdoDescriptors (Default: false)", 2 );
                append( sb, "Whether to generate JDO-specific descriptor classes or not.", 3 );
                append( sb, "", 0 );

                append( sb, "descriptors (Default: true)", 2 );
                append( sb, "If true, generate descriptors", 3 );
                append( sb, "", 0 );

                append( sb, "dest", 2 );
                append( sb, "The directory to output the generated sources to", 3 );
                append( sb, "", 0 );

                append( sb, "generateImportedSchemas (Default: false)", 2 );
                append( sb, "Whether to generate Java classes from imported XML schemas or not.", 3 );
                append( sb, "", 0 );

                append( sb, "generateMappings (Default: false)", 2 );
                append( sb, "Set to true to generate Castor XML class mappings for the Java classes generated by the XML code generator from imported XML schemas.", 3 );
                append( sb, "", 0 );

                append( sb, "lineSeparator", 2 );
                append( sb, "The line separator to use in generated source. Can be either win, unix, or mac", 3 );
                append( sb, "", 0 );

                append( sb, "marshal (Default: true)", 2 );
                append( sb, "if false, don\'t generate the marshaller", 3 );
                append( sb, "", 0 );

                append( sb, "packaging", 2 );
                append( sb, "The package for the generated source", 3 );
                append( sb, "", 0 );

                append( sb, "project", 2 );
                append( sb, "The Maven project to act upon.", 3 );
                append( sb, "", 0 );

                append( sb, "properties", 2 );
                append( sb, "The castorbuilder.properties file to use", 3 );
                append( sb, "", 0 );

                append( sb, "resourceDestination", 2 );
                append( sb, "The directory to output generated resources files to.", 3 );
                append( sb, "", 0 );

                append( sb, "schema", 2 );
                append( sb, "A schema file to process. If this is not set then all .xsd files in schemaDirectory will be processed.", 3 );
                append( sb, "", 0 );

                append( sb, "schemaDirectory", 2 );
                append( sb, "The source directory containing *.xsd files", 3 );
                append( sb, "", 0 );

                append( sb, "staleMillis (Default: 0)", 2 );
                append( sb, "The granularity in milliseconds of the last modification date for testing whether a source needs recompilation", 3 );
                append( sb, "", 0 );

                append( sb, "tstamp", 2 );
                append( sb, "The directory to store the processed xsds. The timestamps of these xsds are used to determine if the source for that xsd need to be regenerated", 3 );
                append( sb, "", 0 );

                append( sb, "types (Default: arraylist)", 2 );
                append( sb, "Castor collection types. Allowable values are \'vector\', \'arraylist\', \'j2\' or \'odmg\' \'j2\' and \'arraylist\' are the same.", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Verbose output during generation", 3 );
                append( sb, "", 0 );

                append( sb, "warnings (Default: false)", 2 );
                append( sb, "Enable warning messages", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "castor:help", 0 );
            append( sb, "Display help information on castor-maven-plugin.\nCall\n\u00a0\u00a0mvn\u00a0castor:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "mapping".equals( goal ) )
        {
            append( sb, "castor:mapping", 0 );
            append( sb, "A mojo that uses Castor MappingTool to generate mapping files from a single Class. MappingTool.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "className", 2 );
                append( sb, "The name of the Java class from which a mapping file should be generated.", 3 );
                append( sb, "", 0 );

                append( sb, "force (Default: false)", 2 );
                append( sb, "Whether to force generation of mapping file where one already exists.", 3 );
                append( sb, "", 0 );

                append( sb, "mappingName", 2 );
                append( sb, "Name of the mapping file to be generated.", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.outputDirectory}/)", 2 );
                append( sb, "The output directory.", 3 );
                append( sb, "", 0 );

                append( sb, "project", 2 );
                append( sb, "The Maven project to act upon.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "mappings".equals( goal ) )
        {
            append( sb, "castor:mappings", 0 );
            append( sb, "A mojo that uses Castor MappingTool to generate mapping files from a set of Classes. MappingTool.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classes", 2 );
                append( sb, "A set of Java classes for which a mapping file should be generated.", 3 );
                append( sb, "", 0 );

                append( sb, "force (Default: false)", 2 );
                append( sb, "Whether to force generation of mapping file where one already exists.", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.outputDirectory}/)", 2 );
                append( sb, "The output directory.", 3 );
                append( sb, "", 0 );

                append( sb, "project", 2 );
                append( sb, "The Maven project to act upon.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
